{******************************************************************************}
{ Projeto: FortesReport Community Edition                                      }
{  um poderoso gerador de relatrios disponvel como um pacote de componentes }
{ para Delphi. Em FortesReport, os relatrios so constitudos por bandas que  }
{ tm funes especficas no fluxo de impresso. Voc definir agrupamentos     }
{ subnveis e totais simplesmente pela relao hierrquica entre as bandas.    }
{ Alm disso possui uma rica paleta de Componentes                             }
{                                                                              }
{ Direitos Autorais Reservados(c) Copyright  1999-2015 Fortes Informtica     }
{                                                                              }
{ Colaboradores nesse arquivo: Ronaldo Moreira                                 }
{                              Mrcio Martins                                  }
{                              Rgys Borges da Silveira                        }
{                              Juliomar Marchetti                              }
{                                                                              }
{  Voc pode obter a ltima verso desse arquivo na pagina do Projeto          }
{  localizado em                                                               }
{ https://github.com/fortesinformatica/fortesreport-ce                         }
{                                                                              }
{  Para mais informaes voc pode consultar o site www.fortesreport.com.br ou }
{  no Yahoo Groups https://groups.yahoo.com/neo/groups/fortesreport/info       }
{                                                                              }
{  Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la }
{ sob os termos da Licena Pblica Geral Menor do GNU conforme publicada pela  }
{ Free Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio) }
{ qualquer verso posterior.                                                   }
{                                                                              }
{  Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM   }
{ NENHUMA GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU      }
{ ADEQUAO A UMA FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor}
{ do GNU para mais detalhes. (Arquivo LICENA.TXT ou LICENSE.TXT)              }
{                                                                              }
{  Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto}
{ com esta biblioteca; se no, escreva para a Free Software Foundation, Inc.,  }
{ no endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.          }
{ Voc tambm pode obter uma copia da licena em:                              }
{ http://www.opensource.org/licenses/gpl-license.php                           }
{                                                                              }
{******************************************************************************}

{******************************************************************************
|* Historico
|*
|* xx/xx/xxxx:  Autor...
|* - Descrio...
******************************************************************************}

{$I RLReport.inc}

{@unit RLConsts - Variveis de internacionalizao e variveis de configurao. }
unit RLConsts;

interface

uses
  Classes,
  {$IfDef CLX}
   QDialogs,
  {$Else}
   Dialogs,
  {$EndIf}
  SysUtils;

const
  {@const ScreenPPI - Resoluo do monitor em pixels por polegada.
   Representa a quantidade de pixels por polegada do vdeo. O valor real varia de monitor para monitor mas,
   para facilitar clculos e tornar os projetos independentes do terminal, essa valor  assumido como sendo 96. :/}
  ScreenPPI = 96;

  {@const InchAsMM - Fator de converso de polegada para milmetros.
   Este fator  utilizado em diversos pontos para converses de coordenadas. :/}
  InchAsMM = 254 / 10;

  {@const MMAsPixels - Fator de converso de milmetros para pixels de tela.
   @links ScreenPPI, InchAsMM. :/}
  MMAsPixels = ScreenPPI / InchAsMM;

  MaxPageNo = 999999;

  ReportFileExt = '.rpf';

  { constantes para exibio na inicializao e no sobre do delphi a partir da verso 2009 }
  cRLSobreDialogoTitulo = 'FortesReport Community Edition';
  cRLSobreTitulo = 'FortesReport Community Edition VCL';
  cRLSobreDescricao = 'FortesReport Community Edition VCL ' + sLineBreak +
                      'http://www.fortesreport.com.br' + sLineBreak +
                      'https://github.com/fortesinformatica/fortesreport-ce' + sLineBreak +
                      'Componentes para Gerao de Relatrios' + sLineBreak +
                      'Lesser General Public License version 2.0';
  cRLSobreLicencaStatus = 'LGPLv2';
  
  {****                                  *}	

const
  CS_CopyrightStr = 'Copyright  1999-2016 Fortes Informtica';
  CS_ProductTitleStr = 'FortesReport Community Edition';
  CS_URLStr = 'http://www.fortesreport.com.br';
  CS_AuthorNameStr = 'Ronaldo Moreira';
  CS_Version = '4.0';

type
  TRLLocaleStrings = record
    {@var LocaleStrings.LS_PrintingInProgressStr - Varivel de internacionalizao para "Imprimindo o relatrio..." :/}
    LS_PrintingInProgressStr: string;
    {@var LS_FilterInProgressStr - Varivel de internacionalizao para "Salvando o relatrio..." :/}
    LS_FilterInProgressStr: string;
    {@var LS_PreparingReportStr - Varivel de internacionalizao para "Preparando o relatrio..." :/}
    LS_PreparingReportStr: string;
    {@var LS_PrinterNotFoundStr - Varivel de internacionalizao para "Nenhuma impressora encontrada" :/}
    LS_PrinterNotFoundStr: string;
    {@var LS_NoPrinterSelected - Varivel de internacionalizao para "Nenhuma impressora selecionada" :/}
    LS_NoPrinterSelected: string;
    {@var LS_NoPathToPrinterStr - Varivel de internacionalizao para "Caminho invlido para a impressora" :/}
    LS_NoPathToPrinterStr: string;
    {@var LS_LoadDefaultConfigStr - Varivel de internacionalizao para "Ser carregada a configurao padro" :/}
    LS_LoadDefaultConfigStr: string;
    {@var LS_PrinterDriverErrorStr - Varivel de internacionalizao para "Erro no driver da impressora" :/}
    LS_PrinterDriverErrorStr: string;
    {@var LS_PageStr - Varivel de internacionalizao para "Pgina" :/}
    LS_PageStr: string;
    {@var LS_PrepareErrorStr - Varivel de internacionalizao para "Erro durante a preparao do relatrio" :/}
    LS_PrepareErrorStr: string;
    {@var LS_PageBreakStr - Varivel de internacionalizao para "Continua..." :/}
    LS_PageBreakStr: string;
    {@var LS_PageMendStr - Varivel de internacionalizao para "Continuao" :/}
    LS_PageMendStr: string;
    {@var LS_ReportEndStr - Varivel de internacionalizao para "Fim" :/}
    LS_ReportEndStr: string;
    {@var LS_FileExists - Translation variable for "File already exists. Overwrite?". :/}
    LS_FileExists: string;
    {@var LS_FileNotFoundStr - Varivel de internacionalizao para "Arquivo no encontrado" :/}
    LS_FileNotFoundStr: string;
    {@var LS_FileNameIsEmpty - Varivel de internacionalizao para "Nome do arquivo no especificado" :/}
    LS_FileNameIsEmpty: string;
    {@var LS_FileNameStr - Varivel de internacionalizao para "Nome do arquivo" :/}
    LS_FileNameStr: string;
    {@var LS_AllFileTypesStr - Varivel de internacionalizao para "Todos os arquivos" :/}
    LS_AllFileTypesStr: string;
    {@var LS_LoadReportStr - Varivel de internacionalizao para "Carregar relatrio" :/}
    LS_LoadReportStr: string;
    {@var LS_NotFoundStr - Varivel de internacionalizao para "No encontrado" :/}
    LS_NotFoundStr: string;
    {@var LS_WaitStr - Varivel de internacionalizao para "Aguarde..." :/}
    LS_WaitStr: string;
    {@var LS_FinishedStr - Varivel de internacionalizao para "Concludo" :/}
    LS_FinishedStr: string;
    {@var LS_CancelStr - Varivel de internacionalizao para "Cancelar" :/}
    LS_CancelStr: string;
    {@var LS_CloseStr - Varivel de internacionalizao para "Fechar" :/}
    LS_CloseStr: string;
    {@var LS_SaveStr - Varivel de internacionalizao para "Salvar" :/}
    LS_SaveStr: string;
    {@var LS_SendStr - Varivel de internacionalizao para "Enviar" :/}
    LS_SendStr: string;
    {@var LS_PrintStr - Varivel de internacionalizao para "Imprimir" :/}
    LS_PrintStr: string;
    {@var LS_AboutTheStr - Varivel de internacionalizao para "Sobre o" :/}
    LS_AboutTheStr: string;
    {@var LS_PreviewStr - Varivel de internacionalizao para "Pr-visualizao" :/}
    LS_PreviewStr: string;
    {@var LS_OfStr - Varivel de internacionalizao para "de" :/}
    LS_OfStr: string;
    {@var LS_ZoomStr - Varivel de internacionalizao para "Zoom" :/}
    LS_ZoomStr: string;
    {@var LS_FirstPageStr - Varivel de internacionalizao para "Primeira pgina" :/}
    LS_FirstPageStr: string;
    {@var LS_PriorPageStr - Varivel de internacionalizao para "Pgina anterior" :/}
    LS_PriorPageStr: string;
    {@var LS_NextPageStr - Varivel de internacionalizao para "Prxima pgina" :/}
    LS_NextPageStr: string;
    {@var LS_LastPageStr - Varivel de internacionalizao para "ltima pgina" :/}
    LS_LastPageStr: string;
    {@var LS_EntirePageStr - Varivel de internacionalizao para "Pgina inteira" :/}
    LS_EntirePageStr: string;
    {@var LS_EntireWidthStr - Varivel de internacionalizao para "Largura da pgina" :/}
    LS_EntireWidthStr: string;
    {@var LS_MultiplePagesStr - Varivel de internacionalizao para "Vrias pginas" :/}
    LS_MultiplePagesStr: string;
    {@var LS_ConfigPrinterStr - Varivel de internacionalizao para "Configurar impressora" :/}
    LS_ConfigPrinterStr: string;
    {@var LS_SaveToFileStr - Varivel de internacionalizao para "Salvar em disco" :/}
    LS_SaveToFileStr: string;
    {@var LS_SendToStr - Varivel de internacionalizao para "Enviar para" :/}
    LS_SendToStr: string;
    {@var LS_PrinterStr - Varivel de internacionalizao para "Impressora" :/}
    LS_PrinterStr: string;
    {@var LS_NameStr - Varivel de internacionalizao para "Nome" :/}
    LS_NameStr: string;
    {@var LS_PrintToFileStr - Varivel de internacionalizao para "Imprimir em arquivo" :/}
    LS_PrintToFileStr: string;
    {@var LS_PrintInBackgroundStr - Varivel de internacionalizao para "Imprimir em segundo plano" :/}
    LS_PrintInBackgroundStr: string;
    {@var LS_OptionsStr - Varivel de internacionalizao para "Opes" de filtragem. :/}
    LS_OptionsStr: string;
    {@var LS_SaveInBackground - Varivel de internacionalizao para "Salvar em segundo plano" :/}
    LS_SaveInBackground: string;
    {@var LS_PageRangeStr - Varivel de internacionalizao para "Intervalo de pginas" :/}
    LS_PageRangeStr: string;
    {@var LS_CopyAsImageStr - Varivel de internacionalizao para "Copiar como Bitmap" :/}
    LS_CopyAsImageStr: string;
    {@var LS_CopyAsMetafile - Varivel de internacionalizao para "Copiar como Metafile" :/}
    LS_CopyAsMetafileStr: string;
    {@var LS_RangeFromStr - Varivel de internacionalizao para "de" :/}
    LS_RangeFromStr: string;
    {@var LS_RangeToStr - Varivel de internacionalizao para "at" :/}
    LS_RangeToStr: string;
    {@var LS_AllStr - Varivel de internacionalizao para "Tudo" :/}
    LS_AllStr: string;
    {@var LS_PagesStr - Varivel de internacionalizao para "Pginas" :/}
    LS_PagesStr: string;
    {@var LS_SelectionStr - Varivel de internacionalizao para "Seleo" :/}
    LS_SelectionStr: string;
    {@var LS_CopiesStr - Varivel de internacionalizao para "Cpias" :/}
    LS_CopiesStr: string;
    {@var LS_NumberOfCopiesStr - Varivel de internacionalizao para "Nmero de cpias" :/}
    LS_NumberOfCopiesStr: string;
    {@var LS_OkStr - Varivel de internacionalizao para "Ok" :/}
    LS_OkStr: string;
    {@var LS_DivideScreenStr - Varivel de internacionalizao para "Dividir a tela" :/}
    LS_DivideScreenStr: string;
    {@var LS_InvalidNameStr - Varivel de internacionalizao para "Nome invlido" :/}
    LS_InvalidNameStr: string;
    {@var LS_DuplicateNameStr - Varivel de internacionalizao para "Nome j utilizado" :/}
    LS_DuplicateNameStr: string;
    {@var LS_UseFilterStr - Varivel de internacionalizao para "Usar Filtro" :/}
    LS_UseFilterStr: string;
    {@var LS_WebPageStr - Varivel de internacionalizao para "Pgina da Web" :/}
    LS_WebPageStr: string;
    {@var LS_RichFormatStr - Varivel de internacionalizao para "Formato RichText" :/}
    LS_RichFormatStr: string;
    {@var LS_PDFFormatStr - Varivel de internacionalizao para "Documento PDF" :/}
    LS_PDFFormatStr: string;
    {@var LS_XLSFormatStr97-2013 - Varivel de internacionalizao para "Planilha Excel 97-2013" :/}
    LS_XLSFormatStr97_2013: string;
    {@var LS_XLSFormatStr - Varivel de internacionalizao para "Planilha Excel" :/}
    LS_XLSFormatStr: string;
    {@var LS_AtStr - Varivel de internacionalizao para "em" :/}
    LS_AtStr: string;
    {@var LS_FormStr - Varivel de internacionalizao para "Formulrio" :/}
    LS_FormStr: string;
    {@var LS_DefaultStr - Varivel de internacionalizao para "Padro" :/}
    LS_DefaultStr: string;
    {@var LS_ZoomInStr - Varivel de internacionalizao para "Aumentar o zoom" :/}
    LS_ZoomInStr: string;
    {@var LS_ZoomOutStr - Varivel de internacionalizao para "Diminuir o zoom" :/}
    LS_ZoomOutStr: string;
    {@var LS_CopyStr - Varivel de internacionalizao para "Copiar" :/}
    LS_CopyStr: string;
    {@var LS_EditStr - Varivel de internacionalizao para "Editar" :/}
    LS_EditStr: string;
    {@var LS_FindCaptionStr - Varivel de internacionalizao para "Procurar" :/}
    LS_FindCaptionStr: string;
    {@var LS_TextToFindStr - Varivel de internacionalizao para "Te&xto" :/}
    LS_TextToFindStr: string;
    {@var LS_FindNextStr - &Varivel de internacionalizao para "Prxima" :/}
    LS_FindNextStr: string;
    {@var LS_WholeWordsStr - Varivel de internacionalizao para "Palavras &inteiras" :/}
    LS_WholeWordsStr: string;
    {@var LS_MatchCaseStr - Varivel de internacionalizao para "Diferenciar &maisculas de minsculas" :/}
    LS_MatchCaseStr: string;
    {@var LS_DirectionUpStr - Varivel de internacionalizao para "A&cima" :/}
    LS_DirectionUpStr: string;
    {@var LS_DirectionDownStr - Varivel de internacionalizao para "A&baixo" :/}
    LS_DirectionDownStr: string;
    {@var LS_DirectionCaptionStr - Varivel de internacionalizao para "Direo" :/}
    LS_DirectionCaptionStr: string;
    {@var LS_ColumnsStr - Varivel de internacionalizao para "Colunas". :/}
    LS_ColumnsStr: string;
    {@var LS_SetupStr - Varivel de internacionalizao para "Configurao". :/}
    LS_SetupStr: string;
    {@var LS_FontSizeError - Varivel de internacionalizao para "Erro no clculo das fontes". :/}
    LS_FontSizeError: string;
    {@var LS_OddPages - Varivel de internacionalizao para "mpares". :/}
    LS_OddPages: string;
    {@var LS_EvenPages - Varivel de internacionalizao para "Pares". :/}
    LS_EvenPages: string;
    {@var LS_OddPagesOnly - Varivel de internacionalizao para "mpares somente". :/}
    LS_OddPagesOnly: string;
    {@var LS_EvenPagesOnly - Varivel de internacionalizao para "Pares somente". :/}
    LS_EvenPagesOnly: string;
    {@var LS_AllOddAndEven - Varivel de internacionalizao para "Todas". :/}
    LS_AllOddAndEven: string;
    {@var LS_PrintDialogError - Varivel de internacionalizao para "Problemas com o dilogo da impressora". :/}
    LS_PrintDialogError: string;
    {@var LS_PageSelectionHint - Varivel de internacionalizao para "Separe com ponto-e-vrgula os nmeros ou intervalos de pginas a imprimir. Ex.: 1;3;5-12;4". :/}
    LS_PageSelectionHint: string;
    {@var LS_DefaultJobTitle - Varivel de internacionalizao para "Relatrio %s". :/}
    LS_DefaultJobTitle: string;
    {@var LS_ZoomHint - Varivel de internacionalizao para "Diminuir o zoom" :/}
    LS_ZoomHint: string;
    {@var Ls_Aplicar - Varivel de internacionalizao para "Aplicar". :/}
    Ls_Aplicar: String;
    {@var Ls_Propriedades - Varivel de internacionalizao para "Propriedades". :/}
    Ls_Propriedades: string;
    {@var Ls_Salvar_Como - Varivel de internacionalizao para "Salvar como". :/}
    Ls_Salvar_Como: string;
    {@var LS_FileCorrupted - Varivel de internacionalizao para "Arquivo corrompido". :/}
    LS_FileCorrupted: String;
    {@var LS_FileCorruptedHeader - Translation variable for "Corrupted file header "%s"!". :/}
    LS_FileCorruptedHeader: string;
    {@var LS_FileVersion - Varivel de internacionalizao para "Verso de Arquivo invlido". :/}
    LS_FileVersion: String;
    {@var Ls_PageSetings - Varivel de internacionalizao para "Configurao da Pgina". :/}
    LS_PageSettings: String;
    {@var Ls_Page_margins - Varivel de internacionalizao para "Margem da Pgina". :/}
    LS_PageMargins: String;
    {@var Ls_PageMarginsTop - Varivel de internacionalizao para "Margem Superior". :/}
    LS_PageMarginsTop: String;
    {@var Ls_PageMarginsBottom - Varivel de internacionalizao para "Margem Inferior". :/}
    LS_PageMarginsBottom: String;
    {@var LS_PageMarginsRigth - Varivel de internacionalizao para "Margem direita". :/}
    LS_PageMarginsRigth: String;
    {@var Ls_PageLeftBottom - Varivel de internacionalizao para "Margem equerda". :/}
    LS_PageMarginsLeft: String;
    {@var LS_PageMarginsPaper - Varivel de internacionalizao para "Margem do Papel". :/}
    LS_PageMarginsPaper: String;
    {@var LS_PagePaper - Varivel de internacionalizao para "Papel". :/}
    LS_PagePaper: String;
    {@var LS_PaperSize - Varivel de internacionalizao para "Tamanho do Papel". :/}
    LS_PaperSize: String;
    {@var LS_PaperWidth - Varivel de internacionalizao para "Largura do Papel". :/}
    LS_PaperSizeWidth: String;
    {@var LS_PaperSizeHeigth - Varivel de internacionalizao para "Altura do Papel". :/}
    LS_PaperSizeHeigth: String;
    {@var LS_PaperOrientation - Varivel de internacionalizao para "Orientao do Papel". :/}
    LS_PaperOrientation: String;
    {@var LS_PaperOrientationLandscape - Varivel de internacionalizao para "Orientao da pgina em retrato". :/}
    LS_PaperOrientationLandscape: String;
    {@var LS_PaperOrientationPortrait - Varivel de internacionalizao para "Orientao da pgina em paisagem". :/}
    LS_PaperOrientationPortrait: String;
    {@var LS_Duplex - Translation variable for "Automatic two-sided printing". :/}
    LS_Duplex: String;
    {@var LS_OnlyOneInstance - Translation variable for "Only one instance of %s is allowed!". :/}
    LS_OnlyOneInstance: String;
    {@var LS_NotImplemented - Translation variable for "%s is not yet implemented for this platform!". :/}
    LS_NotImplemented: String;
    {@var LS_NoHandle - Translation variable for "Handle not available!". :/}
    LS_NoHandle: String;

    LS_LastFooMsg: string;
  end;

var
  LocaleStrings: TRLLocaleStrings;
  ReportServiceMode: Boolean = False;

procedure DetectLocale;

{/@unit}


implementation

var
  KnownCommercialVersion: Integer = 0;
  KnownReleaseVersion: Integer = 0;
  KnownCommentVersion: string = '';

var
  EnglishStrings: TRLLocaleStrings = (
    LS_PrintingInProgressStr: 'Printing in progress...';
    LS_FilterInProgressStr: 'Saving report...';
    LS_PreparingReportStr: 'Preparing report...';
    LS_PrinterNotFoundStr: 'Printer not found';
    LS_NoPrinterSelected: 'No printer selected.';
    LS_NoPathToPrinterStr: 'Invalid printer path';
    LS_LoadDefaultConfigStr: 'Load default configuration';
    LS_PrinterDriverErrorStr: 'Printer driver error';
    LS_PageStr: 'Page';
    LS_PrepareErrorStr: 'Error while preparing report';
    LS_PageBreakStr: 'Continues...';
    LS_PageMendStr: 'Continuation';
    LS_ReportEndStr: 'End';
    LS_FileExists: 'File already exists. Overwrite?';
    LS_FileNotFoundStr: 'File not found';
    LS_FileNameIsEmpty: 'File name not Specified';
    LS_FileNameStr: 'File Name';
    LS_AllFileTypesStr: 'All files';
    LS_LoadReportStr: 'Load report';
    LS_NotFoundStr: 'Not found';
    LS_WaitStr: 'Wait...';
    LS_FinishedStr: 'Finished';
    LS_CancelStr: 'Cancel';
    LS_CloseStr: 'Close';
    LS_SaveStr: 'Save';
    LS_SendStr: 'Send';
    LS_PrintStr: 'Print';
    LS_AboutTheStr: 'About';
    LS_PreviewStr: 'Preview';
    LS_OfStr: 'of';
    LS_ZoomStr: 'Zoom';
    LS_FirstPageStr: 'First page';
    LS_PriorPageStr: 'Prior page';
    LS_NextPageStr: 'Next page';
    LS_LastPageStr: 'Last page';
    LS_EntirePageStr: 'Entire page';
    LS_EntireWidthStr: 'Entire width';
    LS_MultiplePagesStr: 'Multiple pages';
    LS_ConfigPrinterStr: 'Configure printer';
    LS_SaveToFileStr: 'Save to file';
    LS_SendToStr: 'Send to';
    LS_PrinterStr: 'Printer';
    LS_NameStr: 'Name';
    LS_PrintToFileStr: 'Print to file';
    LS_PrintInBackgroundStr: 'Print in background';
    LS_OptionsStr: 'Options';
    LS_SaveInBackground: 'Save in background';
    LS_PageRangeStr: 'Page range';
    LS_CopyAsImageStr: 'Copy as Bitmap';
    LS_CopyAsMetafileStr: 'Copy as Metafile';
    LS_RangeFromStr: 'from';
    LS_RangeToStr: 'to';
    LS_AllStr: 'All';
    LS_PagesStr: 'Pages';
    LS_SelectionStr: 'Selection';
    LS_CopiesStr: 'Copies';
    LS_NumberOfCopiesStr: 'Number of copies';
    LS_OkStr: 'OK';
    LS_DivideScreenStr: 'Divide the screen';
    LS_InvalidNameStr: 'Invalid name';
    LS_DuplicateNameStr: 'Name already in use';
    LS_UseFilterStr: 'Use filter';
    LS_WebPageStr: 'Web page';
    LS_RichFormatStr: 'RichText Format';
    LS_PDFFormatStr: 'PDF Document';
    LS_XLSFormatStr97_2013: 'Excel spreadsheet 97-2013';
    LS_XLSFormatStr: 'Excel spreadsheet';
    LS_AtStr: 'at';
    LS_FormStr: 'Form';
    LS_DefaultStr: 'Default';
    LS_ZoomInStr: 'Increase zoom';
    LS_ZoomOutStr: 'Decrease zoom';
    LS_CopyStr: 'Copy';
    LS_EditStr: 'Edit';
    LS_FindCaptionStr: 'Find';
    LS_TextToFindStr: 'Te&xt';
    LS_FindNextStr: 'Find &Next';
    LS_WholeWordsStr: '&Whole words only';
    LS_MatchCaseStr: '&Match Case';
    LS_DirectionUpStr: '&Up';
    LS_DirectionDownStr: '&Down';
    LS_DirectionCaptionStr: 'Direction';
    LS_ColumnsStr: 'Columns';
    LS_SetupStr: 'Setup...';
    LS_FontSizeError: 'Font size error';
    LS_OddPages: 'Odd';
    LS_EvenPages: 'Even';
    LS_OddPagesOnly: 'Odd pages only';
    LS_EvenPagesOnly: 'Even pages only';
    LS_AllOddAndEven: 'All';
    LS_PrintDialogError: 'Problems with print dialog';
    LS_PageSelectionHint: 'Separate page numbers or page intervals with ";". i.e.: 1;3;5-12;4';
    LS_DefaultJobTitle: 'Report "%s"';
    LS_ZoomHint: 'Change zoom level';
    Ls_Aplicar: 'Use';
    LS_Propriedades: 'Settings';
    LS_Salvar_Como: 'Save as';
    LS_FileCorrupted: 'File is corrupted!';
    LS_FileCorruptedHeader: 'Corrupted file header "%s"!';
    LS_FileVersion: 'Invalid file version %d!';
    LS_PageSettings: 'Page Configuration';
    LS_PageMargins: 'Margins';
    LS_PageMarginsTop: 'Top';
    LS_PageMarginsBottom: 'Bottom';
    LS_PageMarginsRigth: 'Right';
    LS_PageMarginsLeft: 'Left';
    LS_PageMarginsPaper: 'Paper Margins';
    LS_PagePaper: 'Paper';
    LS_PaperSize: 'Paper Size';
    LS_PaperSizeWidth: 'Width';
    LS_PaperSizeHeigth: 'Height';
    LS_PaperOrientation: 'Orientation';
    LS_PaperOrientationLandscape: 'Landscape';
    LS_PaperOrientationPortrait: 'Portrait';
    LS_Duplex: 'Automatic two-sided printing';
    LS_OnlyOneInstance: 'Only one instance of %s is allowed!';
    LS_NotImplemented: '%s is not yet implemented for this platform!';
    LS_NoHandle: 'Handle not available!';

    LS_LastFooMsg: '';
  );

var
  PortugueseStrings: TRLLocaleStrings = (
    LS_PrintingInProgressStr: 'Imprimindo o relatrio...';
    LS_FilterInProgressStr: 'Salvando o relatrio...';
    LS_PreparingReportStr: 'Preparando o relatrio...';
    LS_PrinterNotFoundStr: 'Nenhuma impressora encontrada';
    LS_NoPrinterSelected: 'Nenhuma impressora selecionada.';
    LS_NoPathToPrinterStr: 'Caminho invlido para a impressora';
    LS_LoadDefaultConfigStr: 'Ser carregada a configurao padro';
    LS_PrinterDriverErrorStr: 'Erro no driver da impressora';
    LS_PageStr: 'Pgina';
    LS_PrepareErrorStr: 'Erro durante a preparao do relatrio';
    LS_PageBreakStr: 'Continua...';
    LS_PageMendStr: 'Continuao';
    LS_ReportEndStr: 'Fim';
    LS_FileExists: 'Arquivo j existe. Sobreescrever?';
    LS_FileNotFoundStr: 'Arquivo no encontrado';
    LS_FileNameIsEmpty: 'Nome do arquivo no especificado';
    LS_FileNameStr: 'Nome do arquivo';
    LS_AllFileTypesStr: 'Todos os arquivos';
    LS_LoadReportStr: 'Carregar relatrio';
    LS_NotFoundStr: 'No encontrado';
    LS_WaitStr: 'Aguarde...';
    LS_FinishedStr: 'Concludo';
    LS_CancelStr: 'Cancelar';
    LS_CloseStr: 'Fechar';
    LS_SaveStr: 'Salvar';
    LS_SendStr: 'Enviar';
    LS_PrintStr: 'Imprimir';
    LS_AboutTheStr: 'Sobre o';
    LS_PreviewStr: 'Pr-visualizao';
    LS_OfStr: 'de';
    LS_ZoomStr: 'Zoom';
    LS_FirstPageStr: 'Primeira pgina';
    LS_PriorPageStr: 'Pgina anterior';
    LS_NextPageStr: 'Prxima pgina';
    LS_LastPageStr: 'ltima pgina';
    LS_EntirePageStr: 'Pgina inteira';
    LS_EntireWidthStr: 'Largura da pgina';
    LS_MultiplePagesStr: 'Vrias pginas';
    LS_ConfigPrinterStr: 'Configurar impressora';
    LS_SaveToFileStr: 'Salvar em disco';
    LS_SendToStr: 'Enviar para';
    LS_PrinterStr: 'Impressora';
    LS_NameStr: 'Nome';
    LS_PrintToFileStr: 'Imprimir em arquivo';
    LS_PrintInBackgroundStr: 'Imprimir em segundo plano';
    LS_OptionsStr: 'Opes';
    LS_SaveInBackground: 'Salvar em segundo plano';
    LS_PageRangeStr: 'Intervalo de pginas';
    LS_CopyAsImageStr: 'Copiar como Bitmap';
    LS_CopyAsMetafileStr: 'Copiar como Metafile';
    LS_RangeFromStr: 'de';
    LS_RangeToStr: 'at';
    LS_AllStr: 'Tudo';
    LS_PagesStr: 'Pginas';
    LS_SelectionStr: 'Seleo';
    LS_CopiesStr: 'Cpias';
    LS_NumberOfCopiesStr: 'Nmero de cpias';
    LS_OkStr: 'OK';
    LS_DivideScreenStr: 'Dividir a tela';
    LS_InvalidNameStr: 'Nome invlido';
    LS_DuplicateNameStr: 'Nome j utilizado';
    LS_UseFilterStr: 'Usar Filtro';
    LS_WebPageStr: 'Pgina da Web';
    LS_RichFormatStr: 'Formato RichText';
    LS_PDFFormatStr: 'Documento PDF';
    LS_XLSFormatStr97_2013: 'Planilha Excel 97-2013';
    LS_XLSFormatStr: 'Planilha Excel';
    LS_AtStr: 'em';
    LS_FormStr: 'Formulrio';
    LS_DefaultStr: 'Padro';
    LS_ZoomInStr: 'Aumentar o zoom';
    LS_ZoomOutStr: 'Diminuir o zoom';
    LS_CopyStr: 'Copiar';
    LS_EditStr: 'Editar';
    LS_FindCaptionStr: 'Procurar';
    LS_TextToFindStr: 'Te&xto';
    LS_FindNextStr: '&Prxima';
    LS_WholeWordsStr: 'Palavras &inteiras';
    LS_MatchCaseStr: 'Diferenciar &maisculas de minsculas';
    LS_DirectionUpStr: 'A&cima';
    LS_DirectionDownStr: 'A&baixo';
    LS_DirectionCaptionStr: 'Direo';
    LS_ColumnsStr: 'Colunas';
    LS_SetupStr: 'Configurao';
    LS_FontSizeError: 'Erro no clculo das fontes';
    LS_OddPages: 'mpares';
    LS_EvenPages: 'Pares';
    LS_OddPagesOnly: 'Somente mpares';
    LS_EvenPagesOnly: 'Somente Pares';
    LS_AllOddAndEven: 'Todas';
    LS_PrintDialogError: 'Problemas com o dilogo da impressora';
    LS_PageSelectionHint: 'Separe com ponto-e-vrgula os nmeros ou intervalos de pginas a imprimir. Ex.: 1;3;5-12;4';
    LS_DefaultJobTitle: 'Relatrio "%s"';
    LS_ZoomHint: 'Voc tambm pode aumentar ou reduzir o zoom do relatrio' + sLineBreak + 'pressionando "Ctrl" e usando a rolagem do mouse.';
    LS_Aplicar: 'Aplicar';
    LS_Propriedades: 'Propriedades';
    LS_Salvar_Como: 'Salvar Como';
    LS_FileCorrupted: 'Arquivo Corrompido';
    LS_FileCorruptedHeader: 'Cabealho de arquivo corrompido "%s"!';
    LS_FileVersion: 'Verso de arquivo invlida %d!';
    LS_PageSettings: 'Configuraes da pgina';
    LS_PageMargins: 'Margem';
    LS_PageMarginsTop: 'Superior';
    LS_PageMarginsBottom: 'Inferior';
    LS_PageMarginsRigth: 'Direita';
    LS_PageMarginsLeft: 'Esquerda';
    LS_PageMarginsPaper: 'Margsss';
    LS_PagePaper: 'Papel';
    LS_PaperSize: 'Tamanho do Papel';
    LS_PaperSizeWidth: 'Largura';
    LS_PaperSizeHeigth: 'Altura';
    LS_PaperOrientation: 'Orienta  o';
    LS_PaperOrientationLandscape: 'Paisagem';
    LS_PaperOrientationPortrait: 'Retrato';
    LS_Duplex: 'Impresso frente e verso';
    LS_OnlyOneInstance: 'Apenas uma instncia de %s  permitida!';
    LS_NotImplemented: '%s ainda no foi implementado para esta plataforma!';
    LS_NoHandle: 'Handle no disponvel!';

    LS_LastFooMsg: '';
  );

var
  FrenchStrings: TRLLocaleStrings = (
    LS_PrintingInProgressStr: 'Impression du rapport...';
    LS_FilterInProgressStr: 'Sauver le rapport...';
    LS_PreparingReportStr: 'Prparation du rapport...';
    LS_PrinterNotFoundStr: 'Imprimante non trouve';
    LS_NoPrinterSelected: 'No printer selected.';
    LS_NoPathToPrinterStr: 'Chemin d''imprimante non valide';
    LS_LoadDefaultConfigStr: 'Chargement de la configuration standard';
    LS_PrinterDriverErrorStr: 'Erreur dans le driver d''impression';
    LS_PageStr: 'Page';
    LS_PrepareErrorStr: 'Erreur durant la prparation du rapport';
    LS_PageBreakStr: 'Suite...';
    LS_PageMendStr: 'A suivre';
    LS_ReportEndStr: 'Fin';
    LS_FileExists: 'File already exists. Overwrite?';
    LS_FileNotFoundStr: 'Fichier non trouv';
    LS_FileNameIsEmpty: 'File name not Specified';
    LS_FileNameStr: 'Nom de Fichier';
    LS_AllFileTypesStr: 'Tous les fichiers';
    LS_LoadReportStr: 'Ouvrir rapport';
    LS_NotFoundStr: 'Non trouv';
    LS_WaitStr: 'Patientez...';
    LS_FinishedStr: 'Fini';
    LS_CancelStr: 'Annuler';
    LS_CloseStr: 'Fermer';
    LS_SaveStr: 'Sauver';
    LS_SendStr: 'Envoyer';
    LS_PrintStr: 'Imprimer';
    LS_AboutTheStr: 'A propos de';
    LS_PreviewStr: 'Aperu avant impression';
    LS_OfStr: 'de';
    LS_ZoomStr: 'Zoom';
    LS_FirstPageStr: 'Premire page';
    LS_PriorPageStr: 'Page prcdente';
    LS_NextPageStr: 'Page suivante';
    LS_LastPageStr: 'Dernire page';
    LS_EntirePageStr: 'Page entire';
    LS_EntireWidthStr: 'Pleine largeur';
    LS_MultiplePagesStr: 'Plusieurs pages';
    LS_ConfigPrinterStr: 'Configuration de l''imprimante';
    LS_SaveToFileStr: 'Enregistrer dans un fichier';
    LS_SendToStr: 'Envoyer ...';
    LS_PrinterStr: 'Imprimante';
    LS_NameStr: 'Nom';
    LS_PrintToFileStr: 'Imprimer dans un fichier';
    LS_PrintInBackgroundStr: 'Imprimer dans background';
    LS_OptionsStr: 'Options';
    LS_SaveInBackground: 'Enregistrer dans background';
    LS_PageRangeStr: 'Intervalle de pages';
    LS_CopyAsImageStr: 'Copie sous forme d''image';
    LS_CopyAsMetafileStr: 'Copy as Metafile';
    LS_RangeFromStr: 'de';
    LS_RangeToStr: '';
    LS_AllStr: 'Tout';
    LS_PagesStr: 'Pages';
    LS_SelectionStr: 'Slection';
    LS_CopiesStr: 'Copies';
    LS_NumberOfCopiesStr: 'Nombre de copies';
    LS_OkStr: 'OK';
    LS_DivideScreenStr: 'cran divis';
    LS_InvalidNameStr: 'Nom invalide';
    LS_DuplicateNameStr: 'Nom rpt';
    LS_UseFilterStr: 'Utiliser un filtre';
    LS_WebPageStr: 'Page Web';
    LS_RichFormatStr: 'Format RichText';
    LS_PDFFormatStr: 'Document en PDF';
    LS_XLSFormatStr97_2013: 'Feuille de calcul Excel 97-2013';
    LS_XLSFormatStr: 'Feuille de calcul Excel';
    LS_AtStr: '';
    LS_FormStr: 'Formulaire';
    LS_DefaultStr: 'Dfaut';
    LS_ZoomInStr: 'Grandir zoom';
    LS_ZoomOutStr: 'Rduire zoom';
    LS_CopyStr: 'Copier';
    LS_EditStr: 'diter';
    LS_FindCaptionStr: 'Trouvaille';
    LS_TextToFindStr: 'Te&xte';
    LS_FindNextStr: 'A&prs';
    LS_WholeWordsStr: 'Mots &entiers seulement';
    LS_MatchCaseStr: 'Cas d''allu&mette';
    LS_DirectionUpStr: 'Le &Haut';
    LS_DirectionDownStr: 'Le &bas';
    LS_DirectionCaptionStr: 'Direction';
    LS_ColumnsStr: 'Cols';
    LS_SetupStr: 'Setup...';
    LS_FontSizeError: 'Erreur dans la taille de police';
    LS_OddPages: 'Impair';
    LS_EvenPages: 'Pair';
    LS_OddPagesOnly: 'Pages impaires seulement';
    LS_EvenPagesOnly: 'Pages paires seulement';
    LS_AllOddAndEven: 'Toutes les pages';
    LS_PrintDialogError: 'Erreur dans la bote de dialogue de l''imprimante';
    LS_PageSelectionHint: 'Spar des numros de page ou des intervalles avec ";". p.ex.: 1;3;5-12;4';
    LS_DefaultJobTitle: 'Rapport "%s"';
    LS_ZoomHint: '';
    LS_Aplicar: 'Appliquer';
    LS_Propriedades: '';
    LS_Salvar_Como: '';
    LS_FileCorrupted: '';
    LS_FileCorruptedHeader: 'Corrupted file header "%s"!';
    LS_FileVersion: 'Invalid file version %d!';
    LS_PageSettings: '';
    LS_PageMargins: '';
    LS_PageMarginsTop: '';
    LS_PageMarginsBottom: '';
    LS_PageMarginsRigth: '';
    LS_PageMarginsLeft: '';
    LS_PageMarginsPaper: '';
    LS_PagePaper: '';
    LS_PaperSize: '';
    LS_PaperSizeWidth: '';
    LS_PaperSizeHeigth: '';
    LS_PaperOrientation: '';
    LS_PaperOrientationLandscape: '';
    LS_PaperOrientationPortrait: '';
    LS_Duplex: 'Automatic two-sided printing';
    LS_OnlyOneInstance: 'Only one instance of %s is allowed!';
    LS_NotImplemented: '%s is not yet implemented for this platform!';
    LS_NoHandle: 'Handle not avaible!';

    LS_LastFooMsg: '';
  );

var
  SpanishStrings: TRLLocaleStrings = (
    LS_PrintingInProgressStr: 'Impresin en marcha...';
    LS_FilterInProgressStr: 'Guardando el informe...';
    LS_PreparingReportStr: 'Preparacin del informe...';
    LS_PrinterNotFoundStr: 'Impresora no encontrada';
    LS_NoPrinterSelected: 'No printer selected.';
    LS_NoPathToPrinterStr: 'Camino de la impresora no es vlido';
    LS_LoadDefaultConfigStr: 'Cargar la configuracin estndar';
    LS_PrinterDriverErrorStr: 'Error en driver de la impresora';
    LS_PageStr: 'Pgina';
    LS_PrepareErrorStr: 'Un error ocurri mientras se preparaba el informe';
    LS_PageBreakStr: 'Contina...';
    LS_PageMendStr: 'Continuacin';
    LS_ReportEndStr: 'Extremo';
    LS_FileExists: 'File already exists. Overwrite?';
    LS_FileNotFoundStr: 'Archivo no encontrado';
    LS_FileNameIsEmpty: 'File name not Specified';
    LS_FileNameStr: 'Nombre del Archivo';
    LS_AllFileTypesStr: 'Todos los archivos';
    LS_LoadReportStr: 'Cargar el informe';
    LS_NotFoundStr: 'No encontrado';
    LS_WaitStr: 'Espera...';
    LS_FinishedStr: 'Finalizado';
    LS_CancelStr: 'Cancelar';
    LS_CloseStr: 'Cerrar';
    LS_SaveStr: 'Guardar';
    LS_SendStr: 'Enviar';
    LS_PrintStr: 'Imprimir';
    LS_AboutTheStr: 'Sobre';
    LS_PreviewStr: 'Ver';
    LS_OfStr: 'de';
    LS_ZoomStr: 'Zoom';
    LS_FirstPageStr: 'Primera pgina';
    LS_PriorPageStr: 'Pgina anterior';
    LS_NextPageStr: 'Pgina siguiente';
    LS_LastPageStr: 'ltima pgina';
    LS_EntirePageStr: 'Pgina entera';
    LS_EntireWidthStr: 'Ancho completo';
    LS_MultiplePagesStr: 'Varias pginas';
    LS_ConfigPrinterStr: 'Configurar la impresora';
    LS_SaveToFileStr: 'Guardar en un archivo';
    LS_SendToStr: 'Envar a';
    LS_PrinterStr: 'Impresora';
    LS_NameStr: 'Nombre';
    LS_PrintToFileStr: 'Imprimir a un archivo';
    LS_PrintInBackgroundStr: 'Imprimir en background';
    LS_OptionsStr: 'Opciones';
    LS_SaveInBackground: 'Guardar en background';
    LS_PageRangeStr: 'Intervalo de pginas';
    LS_CopyAsImageStr: 'Copiar como imagen';
    LS_CopyAsMetafileStr: 'Copy as Metafile';
    LS_RangeFromStr: 'de';
    LS_RangeToStr: 'a';
    LS_AllStr: 'Todas';
    LS_PagesStr: 'Pginas';
    LS_SelectionStr: 'Seleccin';
    LS_CopiesStr: 'Copias';
    LS_NumberOfCopiesStr: 'Nmero de copias';
    LS_OkStr: 'OK';
    LS_DivideScreenStr: 'Dividir la pantalla';
    LS_InvalidNameStr: 'Nombre invlido';
    LS_DuplicateNameStr: 'Nombre ya en uso';
    LS_UseFilterStr: 'Usar Filtro';
    LS_WebPageStr: 'Pgina Web';
    LS_RichFormatStr: 'Formato RichText';
    LS_PDFFormatStr: 'Documento PDF';
    LS_XLSFormatStr97_2013: 'Hoja de clculo Excel 97-2013';
    LS_XLSFormatStr: 'Hoja de clculo Excel';
    LS_AtStr: 'en';
    LS_FormStr: 'Formulario';
    LS_DefaultStr: 'Estndar';
    LS_ZoomInStr: 'Aumentar zoom';
    LS_ZoomOutStr: 'Disminuir zoom';
    LS_CopyStr: 'Copiar';
    LS_EditStr: 'Editar';
    LS_FindCaptionStr: 'Buscar';
    LS_TextToFindStr: 'Te&xto';
    LS_FindNextStr: '&Siguiente';
    LS_WholeWordsStr: 'Palabras &completas slamente';
    LS_MatchCaseStr: 'Diferenciar &maysculas y minsculas';
    LS_DirectionUpStr: 'En&cima';
    LS_DirectionDownStr: '&Abajo';
    LS_DirectionCaptionStr: 'Direccin';
    LS_ColumnsStr: 'Cols';
    LS_SetupStr: 'Configuracin...';
    LS_FontSizeError: 'Error en el clculo de las fuentes';
    LS_OddPages: 'Impares';
    LS_EvenPages: 'Pares';
    LS_OddPagesOnly: 'Slo Impares';
    LS_EvenPagesOnly: 'Slo Pares';
    LS_AllOddAndEven: 'Todas';
    LS_PrintDialogError: 'Problemas con el dilogo de la impresora';
    LS_PageSelectionHint: 'Separar con ";" los nmeros o rangos de pginas para imprimir. Ex.: 1;3;5-12;4';
    LS_DefaultJobTitle: 'Impresin "%s"';
    LS_ZoomHint: '';
    LS_Aplicar: '';
    LS_Propriedades: '';
    LS_Salvar_Como: '';
    LS_FileCorrupted: '';
    LS_FileCorruptedHeader: 'Corrupted file header "%s"!';
    LS_FileVersion: 'Invalid file version %d!';
    LS_PageSettings: '';
    LS_PageMargins: '';
    LS_PageMarginsTop: '';
    LS_PageMarginsBottom: '';
    LS_PageMarginsRigth: '';
    LS_PageMarginsLeft: '';
    LS_PageMarginsPaper: '';
    LS_PagePaper: '';
    LS_PaperSize: '';
    LS_PaperSizeWidth: '';
    LS_PaperSizeHeigth: '';
    LS_PaperOrientation: '';
    LS_PaperOrientationLandscape: '';
    LS_PaperOrientationPortrait: '';
    LS_Duplex: 'Automatic two-sided printing';
    LS_OnlyOneInstance: 'Only one instance of %s is allowed!';
    LS_NotImplemented: '%s is not yet implemented for this platform!';
    LS_NoHandle: 'Handle not available!';

    LS_LastFooMsg: '';
  );

var
  ItalianStrings: TRLLocaleStrings = (
    LS_PrintingInProgressStr: 'Impression du rapport...';
    LS_FilterInProgressStr: 'Sauver le rapport...';
    LS_PreparingReportStr: 'Prparation du rapport...';
    LS_PrinterNotFoundStr: 'Imprimante non trouve';
    LS_NoPrinterSelected: 'No printer selected.';
    LS_NoPathToPrinterStr: 'Invalid printer path';
    LS_LoadDefaultConfigStr: 'Chargement de la configuration standard';
    LS_PrinterDriverErrorStr: 'Erreur dans le driver d''impression';
    LS_PageStr: 'Page';
    LS_PrepareErrorStr: 'Erreur durant la prpartaion du rapport';
    LS_PageBreakStr: 'Continua...';
    LS_PageMendStr: 'Continuazione';
    LS_ReportEndStr: 'Fine';
    LS_FileExists: 'File already exists. Overwrite?';
    LS_FileNotFoundStr: 'Archivio non fond';
    LS_FileNameIsEmpty: 'File name not Specified';
    LS_FileNameStr: 'Nome di file';
    LS_AllFileTypesStr: 'Tutti archiviano';
    LS_LoadReportStr: 'Rapporto di carico';
    LS_NotFoundStr: 'Non fondato';
    LS_WaitStr: 'Attesa...';
    LS_FinishedStr: 'Finito';
    LS_CancelStr: 'Annulli';
    LS_CloseStr: 'Vicino';
    LS_SaveStr: 'Salvataggio';
    LS_SendStr: 'Spinta dellonda';
    LS_PrintStr: 'Stampa';
    LS_AboutTheStr: 'Circa';
    LS_PreviewStr: 'Anteprima';
    LS_OfStr: 'di';
    LS_ZoomStr: 'Zoom';
    LS_FirstPageStr: 'Prima la pagina';
    LS_PriorPageStr: 'Antecedente la pagina';
    LS_NextPageStr: 'Prossimo pagina';
    LS_LastPageStr: 'Ultima pagina';
    LS_EntirePageStr: 'Pagina intera';
    LS_EntireWidthStr: 'Ampiezza intera';
    LS_MultiplePagesStr: 'Pagine multiple';
    LS_ConfigPrinterStr: 'Configuri stampante';
    LS_SaveToFileStr: 'Salvi archiviare';
    LS_SendToStr: 'Spedisca a';
    LS_PrinterStr: 'Stampante';
    LS_NameStr: 'Nome';
    LS_PrintToFileStr: 'Stampi archiviare';
    LS_PrintInBackgroundStr: 'Stampi in sfondo';
    LS_OptionsStr: 'Opzioni';
    LS_SaveInBackground: 'Salvi in sfondo';
    LS_PageRangeStr: 'Serie di pagina';
    LS_CopyAsImageStr: 'Copy as Bitmap';
    LS_CopyAsMetafileStr: 'Copy as Metafile';
    LS_RangeFromStr: 'da';
    LS_RangeToStr: 'a';
    LS_AllStr: 'Tutti';
    LS_PagesStr: 'Pagine';
    LS_SelectionStr: 'Selezione';
    LS_CopiesStr: 'Copie';
    LS_NumberOfCopiesStr: 'Numero di copie';
    LS_OkStr: 'OK';
    LS_DivideScreenStr: 'Divida lo schermo';
    LS_InvalidNameStr: 'Nome nullo';
    LS_DuplicateNameStr: 'Gi chiami in uso';
    LS_UseFilterStr: 'Filtro di uso';
    LS_WebPageStr: 'Pagina di Web';
    LS_RichFormatStr: 'RichText Format';
    LS_PDFFormatStr: 'PDF Document';
    LS_XLSFormatStr97_2013: 'Eccella foglio di calcolo elettronico 97-2013';
    LS_XLSFormatStr: 'Eccella foglio di calcolo elettronico';
    LS_AtStr: 'a';
    LS_FormStr: 'Forma';
    LS_DefaultStr: 'Contumacia';
    LS_ZoomInStr: 'Zoom di aumento';
    LS_ZoomOutStr: 'Zoom di calo';
    LS_CopyStr: 'Copia';
    LS_EditStr: 'Compili';
    LS_FindCaptionStr: 'Trouvaille';
    LS_TextToFindStr: 'Testo';
    LS_FindNextStr: 'Trovi Prossimo';
    LS_WholeWordsStr: 'Parole intere solamente';
    LS_MatchCaseStr: 'Accoppi Caso';
    LS_DirectionUpStr: 'Su';
    LS_DirectionDownStr: 'In gi';
    LS_DirectionCaptionStr: 'Direzione';
    LS_ColumnsStr: 'Colonnas';
    LS_SetupStr: 'Setup...';
    LS_FontSizeError: 'Font size error';
    LS_OddPages: 'Odd';
    LS_EvenPages: 'Even';
    LS_OddPagesOnly: 'Odd pages only';
    LS_EvenPagesOnly: 'Even pages only';
    LS_AllOddAndEven: 'All';
    LS_PrintDialogError: 'Problems calling the printer dialog';
    LS_PageSelectionHint: 'Separate page numbers or page intervals with ";". i.e.: 1;3;5-12;4';
    LS_DefaultJobTitle: 'Rapporto "%s"';
    LS_ZoomHint: '';
    LS_Aplicar: '';
    LS_Propriedades: '';
    LS_Salvar_Como: '';
    LS_FileCorrupted: '';
    LS_FileCorruptedHeader: 'Corrupted file header "%s"!';
    LS_FileVersion: 'Invalid file version %d!';
    LS_PageSettings: '';
    LS_PageMargins: '';
    LS_PageMarginsTop: '';
    LS_PageMarginsBottom: '';
    LS_PageMarginsRigth: '';
    LS_PageMarginsLeft: '';
    LS_PageMarginsPaper: '';
    LS_PagePaper: '';
    LS_PaperSize: '';
    LS_PaperSizeWidth: '';
    LS_PaperSizeHeigth: '';
    LS_PaperOrientation: '';
    LS_PaperOrientationLandscape: '';
    LS_PaperOrientationPortrait: '';
    LS_Duplex: 'Automatic two-sided printing';
    LS_OnlyOneInstance: 'Only one instance of %s is allowed!';
    LS_NotImplemented: '%s is not yet implemented for this platform!';
    LS_NoHandle: 'Handle not available!';

    LS_LastFooMsg: '';
  );

var
  SwedishStrings: TRLLocaleStrings = (
    LS_PrintingInProgressStr: 'Das Drucken im Gange...';
    LS_FilterInProgressStr: 'Das Sparen von Bericht  ...';
    LS_PreparingReportStr: 'Das Vorbereiten von Berich...';
    LS_PrinterNotFoundStr: 'Drucker fand nicht';
    LS_NoPrinterSelected: 'No printer selected.';
    LS_NoPathToPrinterStr: 'Ungltiger Druckerpfad';
    LS_LoadDefaultConfigStr: 'Laden Sie Standardkonfiguration';
    LS_PrinterDriverErrorStr: 'Druckerfahrer Fehler';
    LS_PageStr: 'Seite';
    LS_PrepareErrorStr: 'Fehler, whrend das Vorbereiten von Bericht';
    LS_PageBreakStr: 'Setzt fort...';
    LS_PageMendStr: 'Fortsetzung';
    LS_ReportEndStr: 'Ende';
    LS_FileExists: 'File already exists. Overwrite?';
    LS_FileNotFoundStr: 'File fand nicht';
    LS_FileNameIsEmpty: 'File name not Specified';
    LS_FileNameStr: 'Akte Name';
    LS_AllFileTypesStr: 'Alles legt ab';
    LS_LoadReportStr: 'Lastbericht';
    LS_NotFoundStr: 'Finden Sie nicht';
    LS_WaitStr: 'Wartezeit...';
    LS_FinishedStr: 'Beendet';
    LS_CancelStr: 'Sagen Sie ab';
    LS_CloseStr: 'Ende';
    LS_SaveStr: 'Ballabwehr';
    LS_SendStr: 'Schicken Sie';
    LS_PrintStr: 'Druck';
    LS_AboutTheStr: 'ber';
    LS_PreviewStr: 'Vorschau';
    LS_OfStr: 'von';
    LS_ZoomStr: 'Gummilinse';
    LS_FirstPageStr: 'Erste Seite';
    LS_PriorPageStr: 'Vorausgehende Seite';
    LS_NextPageStr: 'Danach Seite';
    LS_LastPageStr: 'Letzte Seite';
    LS_EntirePageStr: 'Ganze Seite';
    LS_EntireWidthStr: 'Ganze Weite';
    LS_MultiplePagesStr: 'Mehrfache Seiten';
    LS_ConfigPrinterStr: 'Konfigurieren Sie Drucker';
    LS_SaveToFileStr: 'Ballabwehr, um abzulegen';
    LS_SendToStr: 'Schicken Sie dazu';
    LS_PrinterStr: 'Drucker';
    LS_NameStr: 'Name';
    LS_PrintToFileStr: 'Drucker, um abzulegen';
    LS_PrintInBackgroundStr: 'Druck in Hintergrund ';
    LS_OptionsStr: 'Mglichkeiten';
    LS_SaveInBackground: 'Ballabwehr in Hintergrund';
    LS_PageRangeStr: 'Rufen Sie Auswahl aus';
    LS_CopyAsImageStr: 'Copy as Bitmap';
    LS_CopyAsMetafileStr: 'Copy as Metafile';
    LS_RangeFromStr: 'von';
    LS_RangeToStr: 'zu';
    LS_AllStr: 'Alles';
    LS_PagesStr: 'Seiten';
    LS_SelectionStr: 'Auswahl';
    LS_CopiesStr: 'Kopien';
    LS_NumberOfCopiesStr: 'Anzahl von Kopien';
    LS_OkStr: 'OK';
    LS_DivideScreenStr: 'Teilen Sie den Bildschirm';
    LS_InvalidNameStr: 'Ungltiger Name';
    LS_DuplicateNameStr: 'Nennen Sie schon im Gebrauch';
    LS_UseFilterStr: 'Verwendungsfilter';
    LS_WebPageStr: 'Webseite';
    LS_RichFormatStr: 'RichText Format';
    LS_PDFFormatStr: 'PDF Document';
    LS_XLSFormatStr97_2013: 'Zeichnen Sie Tabelle aus 97-2013';
    LS_XLSFormatStr: 'Zeichnen Sie Tabelle aus';
    LS_AtStr: 'bei';
    LS_FormStr: 'Form';
    LS_DefaultStr: 'Versumnis';
    LS_ZoomInStr: 'Zunahmegummilinse';
    LS_ZoomOutStr: 'Abnahmengummilinse';
    LS_CopyStr: 'Kopie';
    LS_EditStr: 'Bearbeiten Sie';
    LS_FindCaptionStr: 'Fund';
    LS_TextToFindStr: 'Te&xt';
    LS_FindNextStr: 'Finden Sie danach';
    LS_WholeWordsStr: '&Ganze Wrter nur';
    LS_MatchCaseStr: '&Passen Sie Fall zusammen';
    LS_DirectionUpStr: '&Auf';
    LS_DirectionDownStr: '&Entlang';
    LS_DirectionCaptionStr: 'Richtung';
    LS_ColumnsStr: 'Sule';
    LS_SetupStr: 'Setup...';
    LS_FontSizeError: 'Font size error';
    LS_OddPages: 'Odd';
    LS_EvenPages: 'Even';
    LS_OddPagesOnly: 'Odd pages only';
    LS_EvenPagesOnly: 'Even pages only';
    LS_AllOddAndEven: 'All';
    LS_PrintDialogError: 'Problems calling the printer dialog';
    LS_PageSelectionHint: 'Separate page numbers or page intervals with ";". i.e.: 1;3;5-12;4';
    LS_DefaultJobTitle: 'Das Drucken "%s"';
    LS_ZoomHint: '';
    LS_Aplicar: '';
    LS_Propriedades: '';
    LS_Salvar_Como: '';
    LS_FileCorrupted: '';
    LS_FileCorruptedHeader: 'Corrupted file header "%s"!';
    LS_FileVersion: 'Invalid file version %d!';
    LS_PageSettings: '';
    LS_PageMargins: '';
    LS_PageMarginsTop: '';
    LS_PageMarginsBottom: '';
    LS_PageMarginsRigth: '';
    LS_PageMarginsLeft: '';
    LS_PageMarginsPaper: '';
    LS_PagePaper: '';
    LS_PaperSize: '';
    LS_PaperSizeWidth: '';
    LS_PaperSizeHeigth: '';
    LS_PaperOrientation: '';
    LS_PaperOrientationLandscape: '';
    LS_PaperOrientationPortrait: '';
    LS_Duplex: 'Automatic two-sided printing';
    LS_OnlyOneInstance: 'Only one instance of %s is allowed!';
    LS_NotImplemented: '%s is not yet implemented for this platform!';
    LS_NoHandle: 'Handle not available!';

    LS_LastFooMsg: '';
  );

var
  RussianStrings: TRLLocaleStrings = (
    LS_PrintingInProgressStr: 'Печать...';
    LS_FilterInProgressStr: 'Сохранение отчета...';
    LS_PreparingReportStr: 'Подготовка отчета...';
    LS_PrinterNotFoundStr: 'Принтер не найден';
    LS_NoPrinterSelected: 'No printer selected.';
    LS_NoPathToPrinterStr: '?еправильный путь принтера';
    LS_LoadDefaultConfigStr: 'Загрузить конфигураци? по умолчанию';
    LS_PrinterDriverErrorStr: 'Ошибка драйвера принтера';
    LS_PageStr: 'Страница';
    LS_PrepareErrorStr: 'Ошибка при подготовке отчета';
    LS_PageBreakStr: 'Продолжает??...';
    LS_PageMendStr: 'Продолжение';
    LS_ReportEndStr: 'Конец';
    LS_FileExists: 'File already exists. Overwrite?';
    LS_FileNotFoundStr: 'Файл не найден';
    LS_FileNameIsEmpty: 'File name not Specified';
    LS_FileNameStr: 'Им? файла';
    LS_AllFileTypesStr: 'В?е файлы';
    LS_LoadReportStr: 'Загрузить отчет';
    LS_NotFoundStr: '?е найден';
    LS_WaitStr: 'Подождите...';
    LS_FinishedStr: 'Завершено';
    LS_CancelStr: 'Отмена';
    LS_CloseStr: 'Закрыть';
    LS_SaveStr: 'Сохранить';
    LS_SendStr: 'Отправить';
    LS_PrintStr: 'Печать';
    LS_AboutTheStr: 'О Программе';
    LS_PreviewStr: 'Предварительный про?мотр';
    LS_OfStr: 'из';
    LS_ZoomStr: 'Маштаб';
    LS_FirstPageStr: 'Перва? ?траница';
    LS_PriorPageStr: 'Предыдуща? ?траница';
    LS_NextPageStr: 'Следующа? ?траница';
    LS_LastPageStr: 'По?ледн?? ?траница';
    LS_EntirePageStr: 'В?? ?траница';
    LS_EntireWidthStr: 'В?? ширина';
    LS_MultiplePagesStr: '?е?колько ?траниц';
    LS_ConfigPrinterStr: '?а?тройка принтера';
    LS_SaveToFileStr: 'Сохранить в файл';
    LS_SendToStr: 'Отправить в';
    LS_PrinterStr: 'Принтер';
    LS_NameStr: 'Им?';
    LS_PrintToFileStr: 'Печать в файл';
    LS_PrintInBackgroundStr: 'Печать в фоне';
    LS_OptionsStr: '?а?ОКки';
    LS_SaveInBackground: 'Сохранение в фоне';
    LS_PageRangeStr: 'Диапазон печати';
    LS_CopyAsImageStr: 'Copy as Bitmap';
    LS_CopyAsMetafileStr: 'Copy as Metafile';
    LS_RangeFromStr: '?';
    LS_RangeToStr: 'по';
    LS_AllStr: 'В?е';
    LS_PagesStr: 'Страницы';
    LS_SelectionStr: 'Выделение';
    LS_CopiesStr: 'Копии';
    LS_NumberOfCopiesStr: 'Кол-во копий';
    LS_OkStr: 'Хорошо';
    LS_DivideScreenStr: 'Разделить ?кран';
    LS_InvalidNameStr: '?еправильное им?';
    LS_DuplicateNameStr: 'Им? уже и?пользует??';
    LS_UseFilterStr: 'Фильтр';
    LS_WebPageStr: 'Веб ?траница';
    LS_RichFormatStr: 'RichText Format';
    LS_PDFFormatStr: 'PDF Документ';
    LS_XLSFormatStr97_2013: '';
    LS_XLSFormatStr: 'Таблица Excel';
    LS_AtStr: 'в';
    LS_FormStr: 'Форма';
    LS_DefaultStr: 'По умолчанию';
    LS_ZoomInStr: 'Увеличить';
    LS_ZoomOutStr: 'Уменьшить';
    LS_CopyStr: 'Копировать';
    LS_EditStr: 'Редактировать';
    LS_FindCaptionStr: '?айти';
    LS_TextToFindStr: 'Те&к?т';
    LS_FindNextStr: '?айти &дальше';
    LS_WholeWordsStr: '&Только ?лово целиком';
    LS_MatchCaseStr: '&Учитывать реги?тр';
    LS_DirectionUpStr: '&Вверх';
    LS_DirectionDownStr: 'В&низ';
    LS_DirectionCaptionStr: '?аправление';
    LS_ColumnsStr: 'Столбцы';
    LS_SetupStr: 'Setup...';
    LS_FontSizeError: 'Font size error';
    LS_OddPages: 'Odd';
    LS_EvenPages: 'Even';
    LS_OddPagesOnly: 'Odd pages only';
    LS_EvenPagesOnly: 'Even pages only';
    LS_AllOddAndEven: 'All';
    LS_PrintDialogError: 'Problems with print dialog';
    LS_PageSelectionHint: 'Separate page numbers or page intervals with ";". i.e.: 1;3;5-12;4';
    LS_DefaultJobTitle: 'Report "%s"';
    LS_ZoomHint: '';
    LS_Aplicar: 'Применить';
    LS_Propriedades: '?а?тройки';
    LS_Salvar_Como: 'Сохранить как';
    LS_FileCorrupted: 'Файл поврежден!';
    LS_FileCorruptedHeader: 'Corrupted file header "%s"!';
    LS_FileVersion: '?еправильна? вер?и? файла %d!';
    LS_PageSettings: '?а?тройка ?траницы';
    LS_PageMargins: 'Пол?';
    LS_PageMarginsTop: 'Верх';
    LS_PageMarginsBottom: '?их';
    LS_PageMarginsRigth: 'Право';
    LS_PageMarginsLeft: 'Лево';
    LS_PageMarginsPaper: '';
    LS_PagePaper: 'Бумага';
    LS_PaperSize: 'Размер бумаги';
    LS_PaperSizeWidth: 'Ширина';
    LS_PaperSizeHeigth: 'Вы?ота';
    LS_PaperOrientation: 'Ориентаци?';
    LS_PaperOrientationLandscape: 'Ландшафтна?';
    LS_PaperOrientationPortrait: 'Портретна?';
    LS_Duplex: 'Automatic two-sided printing';
    LS_OnlyOneInstance: 'Only one instance of %s is allowed!';
    LS_NotImplemented: '%s is not yet implemented for this platform!';
    LS_NoHandle: 'Handle not available!';

    LS_LastFooMsg: '';
  );

var
  CzechStrings: TRLLocaleStrings = (
    LS_PrintingInProgressStr: 'Probh tisk...';
    LS_FilterInProgressStr: 'Ukldm report...';
    LS_PreparingReportStr: 'Pipravuji report...';
    LS_PrinterNotFoundStr: 'Tiskrna nenalezena';
    LS_NoPrinterSelected: 'Nen vybrna dn tiskrna.';
    LS_NoPathToPrinterStr: 'Chybn cesta k tiskrn';
    LS_LoadDefaultConfigStr: 'Nast implicitn nastaven';
    LS_PrinterDriverErrorStr: 'Chyba ovladae tisku';
    LS_PageStr: 'Strnka';
    LS_PrepareErrorStr: 'Chyba bhem ppravy reportu';
    LS_PageBreakStr: 'Pokrauje...';
    LS_PageMendStr: 'Pokraovn';
    LS_ReportEndStr: 'Konec';
    LS_FileExists: 'Soubor ji existuje. Pepsat?';
    LS_FileNotFoundStr: 'Soubor nenalezen';
    LS_FileNameIsEmpty: 'File name not Specified';
    LS_FileNameStr: 'Nzev souboru';
    LS_AllFileTypesStr: 'Vechny soubory';
    LS_LoadReportStr: 'Nast report';
    LS_NotFoundStr: 'Nenalezeno';
    LS_WaitStr: 'ekejte...';
    LS_FinishedStr: 'Ukoneno';
    LS_CancelStr: 'Zruit';
    LS_CloseStr: 'Zavt';
    LS_SaveStr: 'Uloit';
    LS_SendStr: 'Poslat';
    LS_PrintStr: 'Tisk';
    LS_AboutTheStr: 'O aplikaci';
    LS_PreviewStr: 'Nhled';
    LS_OfStr: 'z';
    LS_ZoomStr: 'Piblen';
    LS_FirstPageStr: 'Prvn strnka';
    LS_PriorPageStr: 'Pedchoz strnka';
    LS_NextPageStr: 'Dal strnka';
    LS_LastPageStr: 'Posledn strnka';
    LS_EntirePageStr: 'Cel strnka';
    LS_EntireWidthStr: 'Na ku';
    LS_MultiplePagesStr: 'Vce strnek';
    LS_ConfigPrinterStr: 'Konfigurace tiskrny';
    LS_SaveToFileStr: 'Uloit do souboru';
    LS_SendToStr: 'Odeslat';
    LS_PrinterStr: 'Tiskrna';
    LS_NameStr: 'Nzev';
    LS_PrintToFileStr: 'Tisk do souboru';
    LS_PrintInBackgroundStr: 'Tisk na pozad';
    LS_OptionsStr: 'Volby';
    LS_SaveInBackground: 'Uloit na pozad';
    LS_PageRangeStr: 'Rozsah strnek';
    LS_CopyAsImageStr: 'Koprovat jako bitmapu';
    LS_CopyAsMetafileStr: 'Koprovat jako metasoubor';
    LS_RangeFromStr: 'od';
    LS_RangeToStr: 'do';
    LS_AllStr: 'Vechny';
    LS_PagesStr: 'Strnky';
    LS_SelectionStr: 'Vbr';
    LS_CopiesStr: 'Kopie';
    LS_NumberOfCopiesStr: 'Poet kopi';
    LS_OkStr: 'OK';
    LS_DivideScreenStr: 'Rozdlit obrazovku';
    LS_InvalidNameStr: 'Chybn nzev';
    LS_DuplicateNameStr: 'Nzev se ji pouv';
    LS_UseFilterStr: 'Pout filtr';
    LS_WebPageStr: 'Webov strnka';
    LS_RichFormatStr: 'Formt RichText';
    LS_PDFFormatStr: 'PDF dokument';
    LS_XLSFormatStr97_2013: 'Tabulka Excel 97-2013';
    LS_XLSFormatStr: 'Tabulka Excel';
    LS_AtStr: 'na';
    LS_FormStr: 'Formul';
    LS_DefaultStr: 'Default';
    LS_ZoomInStr: 'Piblit';
    LS_ZoomOutStr: 'Oddlit';
    LS_CopyStr: 'Koprovat';
    LS_EditStr: 'Upravit';
    LS_FindCaptionStr: 'Najt';
    LS_TextToFindStr: 'Te&xt';
    LS_FindNextStr: 'Najt &dal';
    LS_WholeWordsStr: '&Pouze cel slova';
    LS_MatchCaseStr: '&Rozliovat velikost psmen';
    LS_DirectionUpStr: '&Nahoru';
    LS_DirectionDownStr: '&Dol';
    LS_DirectionCaptionStr: 'Orientace';
    LS_ColumnsStr: 'Sloupce';
    LS_SetupStr: 'Nastaven...';
    LS_FontSizeError: 'Chyba velikosti textu';
    LS_OddPages: 'Sud';
    LS_EvenPages: 'Lich';
    LS_OddPagesOnly: 'Pouze sud strnky';
    LS_EvenPagesOnly: 'Pouze lich strnky';
    LS_AllOddAndEven: 'Vechny';
    LS_PrintDialogError: 'Problm s dialogem tisku';
    LS_PageSelectionHint: 'Oddlen sla strnek stednkem nebo rozmez strnek s pomlkou. tj.: 1;3;5-12;4';
    LS_DefaultJobTitle: 'Report "%s"';
    LS_ZoomHint: 'Upravit piblen.';
    LS_Aplicar: 'Pout';
    LS_Propriedades: 'Nastaven';
    LS_Salvar_Como: 'Uloit jako';
    LS_FileCorrupted: 'Soubor je pokozen!';
    LS_FileCorruptedHeader: 'Pokozen hlavika souboru "%s"!';
    LS_FileVersion: 'Chybn typ souboru %d!';
    LS_PageSettings: 'Nastaven strnky';
    LS_PageMargins: 'Okraje';
    LS_PageMarginsTop: 'Nahoe';
    LS_PageMarginsBottom: 'Dole';
    LS_PageMarginsRigth: 'Vpravo';
    LS_PageMarginsLeft: 'Vlevo';
    LS_PageMarginsPaper: 'Okraje papru';
    LS_PagePaper: 'Papr';
    LS_PaperSize: 'Velikost papru';
    LS_PaperSizeWidth: 'ka';
    LS_PaperSizeHeigth: 'Vka';
    LS_PaperOrientation: 'Orientace';
    LS_PaperOrientationLandscape: 'Na ku';
    LS_PaperOrientationPortrait: 'Na vku';
    LS_Duplex: 'Automatick oboustrann tisk';
    LS_OnlyOneInstance: 'Je povolena pouze jedna instance %s!';
    LS_NotImplemented: '%s nen implementovno na tto platform!';
    LS_NoHandle: 'Handle nen dostupn!';

    LS_LastFooMsg: '';
  );

procedure DetectLocale;
{$IfNDef MSWINDOWS}
var
  dlct: string;
{$EndIf}
begin
{$IfNDef MSWINDOWS}
  dlct := AnsiUpperCase(Copy(GetEnvironmentVariable('LANG'), 1, 2));
  if dlct = 'EN' then
    LocaleStrings := EnglishStrings
  else if dlct = 'PT' then
    LocaleStrings := PortugueseStrings
  else if dlct = 'ES' then
    LocaleStrings := SpanishStrings
  else if dlct = 'FR' then
    LocaleStrings := FrenchStrings
  else if dlct = 'IT' then
    LocaleStrings := ItalianStrings
  else if dlct = 'SW' then
    LocaleStrings := SwedishStrings
  else if dlct = 'RU' then
    LocaleStrings := RussianStrings
  else if dlct = 'CS' then
    LocaleStrings := CzechStrings
  else
    LocaleStrings := EnglishStrings;
{$Else}
  case SysLocale.PriLangID of
    $09 {LANG_ENGLISH}: LocaleStrings := EnglishStrings;
    $16 {LANG_PORTUGUESE}: LocaleStrings := PortugueseStrings;
    $0a {LANG_SPANISH}: LocaleStrings := SpanishStrings;
    $0c {LANG_FRENCH}: LocaleStrings := FrenchStrings;
    $10 {LANG_ITALIAN}: LocaleStrings := ItalianStrings;
    $1d {LANG_SWEDISH}: LocaleStrings := SwedishStrings;
    $19 {LANG_RUSSIAN}: LocaleStrings := RussianStrings;
    $05 {LANG_CZECH}: LocaleStrings := CzechStrings;
  else
    LocaleStrings := EnglishStrings;
  end;
{$EndIf}
end;

initialization
  DetectLocale;

end.
